$title(MAC65/XL Cartridge  (c) 1988 ICD Inc)
$subtitle(Cartridge bank C for MAC65)
$include "equate.asm"
$include "tokens.asm"

	seg	bankc

;	symbol table sorter
;	-------------------
sortsymbols: proc
sort0	lda	#0		; clear exchange
	sta	swapsort
	lda	#'@'-1		; init index
	sta	sindex

sort1	lda	sindex		; get index
	inc	sindex		; bump
	cmp	#'Z'+1		; done a pass?
	bcc	sort2		; no
	lda	swapsort	; do another?
	bne	sort0		; yup
	rts	

sort2	asl	a		; double index
	tax	
	ldy	spointer-'?'*2+1,x	; high link
	bmi	sort1		; nothing

	jsr	formtop		; form topsort

	clc			; form labelptr
	txa	
	adc	#low (spointer-'?'*2-4)
	tax	
	lda	#high (spointer-'?'*2-4)
	adc	#0

			; a = high  x = low
sort11	sta	bckptr+1
	stx	bckptr

	ldy	#5		; last?
	lda	(labelptr),y
	bmi	sort1		; yup

	jsr	formlab		; form fwd pointer
	sty	fwdptr
	sta	fwdptr+1

			; comparison
	ldy	#0		; compare offsets
	lda	(labelptr),y
	cmp	(fwdptr),y
	bcc	sort7
	beq	sort7
	lda	(fwdptr),y
	dey			; set y =$ff

sort7	sta	maxsort
	dec	maxsort
	sty	hilosort
	ldy	#6		; compare chars
	bne	sort9		; skip 1st char

sort8	iny			; bump to next
	lda	(labelptr),y
	cmp	(fwdptr),y
	bcc	notswap
	bne	yesswap

sort9	cpy	maxsort		; at length?
	bcc	sort8		; no
	lda	hilosort	; by offset
	beq	notswap		; smaller in place

yesswap	ldy	#5		; index for exchange
	sty	swapsort	; show exch (<>0)

sort6	lda	(labelptr),y
	tax	
	lda	(bckptr),y
	sta	(labelptr),y
	pha			; ff
	txa	
	sta	(bckptr),y

	lda	(fwdptr),y
	sta	(labelptr),y
	pla			; ff
	sta	(fwdptr),y

	dey	
	cpy	#4
	bcs	sort6

	ldx	fwdptr		; save fwd pointer
	lda	fwdptr+1
	bne	sort11		; unc

notswap
	ldx	labelptr	; save topsort
	lda	labelptr+1

	ldy	fwdptr		; point to new
	sty	labelptr	; topsort
	ldy	fwdptr+1
	sty	labelptr+1
	bne	sort11		; unc
	endproc


;=============================================
;	decode & move text line pointed
;	to by stmcur to inbuff
;	-------------------------------
_edtv:	proc
	sta	cmdlg		; save line length
	stx	labpt		; pointer to
	sty	labpt+1		; tokenized line
	ldy	#0		; clear text index
	sty	cix
	jsr	intlbf
	ldx	supr		; do line #?
	bne	cov2		; nope!

	iny			; move line # (y=1)
	lda	(labpt),y	; to fr0 for
	sta	fr0+1		; conversion to ascii
	lda	(labpt,x)	; (x=0)
	sta	fr0
	jsr	inii		; integer to ascii
	jsr	intlbf
	ldy	#-1

..cc1	iny			; find end of number
	lda	(inbuff),y
	bpl	..cc1
	and	#$7f		; mask 7th bit
	sta	(inbuff),y
	iny	
	sty	cix		; start of text index
	bit	system		; bump colunm?
	bmi	..cc2
	 iny	
..cc2	sty	rpsp		; char past l. #
	lda	eaf		; in asm mode?
	beq	..regl		; no

	lda	inmac		; in macrox?
	beq	..regl		; no
	lda	optflag		; option 'no num'?
	and	#$10
	beq	..regl

	asl	a		; a=$20, change
chli	sta	(inbuff),y	; line # to spaces
	dey	
	bpl	chli

..regl	jsr	p20		; always leading space
cov2	ldy	#2		; init labpt ptr
	sty	ttix

			; convert tokens to text
pu1	jsr	ifd		; get token
	bcs	pu9		; br if end
	beq	cver		; convert error
	bpl	cvst		; a statement
	jsr	cvlb		; convert label
	beq	pu1		; unc, get nxt

cvst	cmp	#@scomment	; comment?
	beq	stmc		; statement commt
	tax			; save code
	jsr	ifstu		; handle if indent
			;    do 1st tab
..tb1	jsr	p20		; pad spaces
	cpy	ztab1		; at nxt colunm?
	bcc	..tb1		; no

	txa			; the code
	ldy	#high statement
	ldx	#low statement	; go cvrt
	jsr	lookup1		; this statement
	cpx	#@macrox	; spec case
	bne	..tb9		; br, not macrox

	jsr	cvmr		; macro name

..tb9			;  do 2nd tab
..tb2	jsr	p20		; pad spaces
	cpy	ztab2		; at nxt col?
	bcc	..tb2		; nope
	jsr	efstu		; endif?

			; convert function loop
cvfunt	jsr	ifd		; get code
	bcs	pu9		; done!
	bpl	pu2		; not a symbol
	jsr	cvlb		; do symbol
	beq	cvfunt		; unc

pu2	cmp	#ch+1		; ck for num
	bcc	cvnm		; convert num
	cmp	#@comment	; comment?
	beq	docmtf		; function commt

	jsr	lookup		; cvrt function
	cpx	#@apost-ch-1	; spec case?
	bne	cvfunt		; get nxt

	jsr	ifd		; for ', get char
	jsr	p58		; put in buff
	bne	cvfunt		; unc get nxt

pu9	lda	#eol		; do eol & ret
	jmp	p58

cver	lda	#low eres	; point to
	sta	fr0		; error message
	lda	#high eres
	sta	fr0+1
	jsr	loo3		; mv error string
	bmi	docmts		; unc

docmtf			;   do 3rd tab
..tb3	jsr	p20		; fill spaces
	cpy	tab3		; at column?
	bcc	..tb3		; no
	bcs	docmts

stmc	ldx	cpad		; pad with spaces?
	beq	docmts		; no
	jsr	ifd		; get leading char
	jsr	p58		; out it
..stmc	jsr	p20		; do padding now
	dex	
	bne	..stmc

docmts	jsr	ifd		; out ascii text
	bcs	pu9		; br if at end
	jsr	p58		; put to buffer
	bne	docmts		; unc, get nxt
	endproc


;	convert number tokens
;	---------------------
cvnm	proc
	cmp	#tdw		; dec or hex?
	php			; save answer
	jsr	gvl		; get interger
	stx	fr0		; low byte
	sta	fr0+1		; high byte
	plp			; pop num type
	bcs	dodc		; br if dec
	 jsr	hex1		; else, hex #
	 jmp	cvfunt		; get nxt

			;   decimal #
dodc			;   mv interger to
	sta	zte4		; holding area
	stx	zte4+1		; x=fr0
	lda	#0		; clear result
	sta	fr0+1
	sta	fr0+2
	sta	fr0+3

	ldy	#15		; convert to 3
	sed			; byte packed bcd
dc2	asl	zte4+1		; format
	rol	zte4
	ldx	#3
dc3	lda	fr0,x
	adc	fr0,x
	sta	fr0,x
	dex	
	bne	dc3
	dey	
	bpl	dc2		; if not 16 times
	cld			; clear dec mode

	inx			; x=1
	lda	fr0+1		; speed up for #s
	ora	fr0+2		; less than 100
	bne	unpack		; no, go unpack
	inx			; point to last bcd

unph	inx			; high nibble
	lda	fr0,x
	lsr	a		; shift in position
	lsr	a
	lsr	a
	lsr	a
	jsr	out

unpack	lda	fr0,x		; low nibble
	cpx	#3		; set end? status
	php			; save it
	bcc	cvr1		; don't force 0
	ldy	#0		; end, always do 0

cvr1	and	#$0f		; mask off high
	jsr	out		; make it ascii
	plp			; get end? status
	bcc	unph		; no, more to do
	jmp	cvfunt		; get nxt function

out	bne	..o		; if non-zero, else
	tya			; ck supress flag
	bne	..k		; br, skip leading 0

..o	ora	#$30		; for ascii
	jsr	p58		; to buffer
	ldy	#0		; clear supress flag
..k	rts			; return
	endproc



;	hex #
;	-----
hex1	proc
	lda	#'$'		; leading $ sign
	jsr	p58
	lda	fr0+1		; skip high if 0
	beq	hxl
	jsr	hexc		; high byte

hxl	lda	fr0		; low byte

hexc	pha			; save byte
	lsr	a		; shift high
	lsr	a		; into position
	lsr	a
	lsr	a
	jsr	hxs		; do nibble

	pla			; pop byte
	and	#$0f		; mask high
hxs	tay			; index into convr
	lda	hext,y		; tab, and to buff
	jmp	p58		; unc
	endproc


;	increment list token pointer
;	----------------------------
ifd	proc
	inc	ttix		; bump index
	ldy	ttix		; get index
	cpy	cmdlg		; set end status
	lda	(labpt),y	; get token
	rts	
	endproc



;	get nums for cvnm
;	-----------------
gvl	proc
	lsr	a		; single or double?
	php			; cc=single
	jsr	ifd		; get token
	tax			; low byte
	plp			; x
	bcs	ifd		; get high & rtn
	lda	#0		; set high =0
	rts	
	endproc


;	convert token symbols
;	---------------------
cvmr	proc
	jsr	ifd		; for macrox name
cvlb	and	#$7f		; count +128 in a
	tax			; use as cntr
cvl1	jsr	ifd		; get char
	jsr	p58		; put char
	dex			; pop cnt
	bne	cvl1		; br if not done
	rts	
	endproc


;	do structered listing format
;	----------------------------
ifstu	proc
	cpx	#@if		; is it if?
	bne	..ata		; no
	inc	ztab1		; bump tabs
	inc	ztab1
	inc	ztab2		; by 2 spaces
	inc	ztab2
	rts	

efstu	cpx	#@endif		; endif?
	bne	..ata
	lda	ztab1		; tst for
	cmp	tab1		; bottom
	beq	..ata		; don't pop tabs
	dec	ztab1
	dec	ztab1
	dec	ztab2
	dec	ztab2
..ata	rts	
	endproc


;	Handle right margin
;	-------------------
rightmr: proc
	lda	cix		; form line length
	clc	
	adc	leftmar		; left margin
	adc	#16		; object field
	cmp	rightmar
	beq	..x
	bcs	hrght		; greater than, go process
..x	jmp	inbout		; it's within margins

hrght	lda	rightmar	; form lbuff index
	sbc	leftmar
	sbc	#16
	tay			; search back index
	pha			; in case fail
	ldx	#12		; limit of twelve characters

loo6	dey	
	dex	
	bmi	loo7		; no space!
	lda	(inbuff),y
	cmp	#$20
	bne	loo6

	pla			; balance stack
	lda	#eol		; rep space with eol
	sta	(inbuff),y
	iny	
	sty	ttix		; character past eol
	jsr	inbout		; print this portion

vect1	lda	ttix		; save buffer index
	pha	
	jsr	tstej		; new line stuff
	jsr	intlbf		; if eject, reset inbuff
	lda	leftmar
	clc	
	adc	#17
	adc	tab3		; begin at comment column
	jsr	space
	pla	
	tay			; dump remainder of line
	jmp	inbout1

			; no space, just chop
loo7	pla			; saved index
	tay	
	dey	
	sty	ttix
	lda	(inbuff),y
	pha			; replace with eol
	lda	#eol
	sta	(inbuff),y
	jsr	inbout		; print first segment
	pla			; restore clobbered char
	ldy	ttix
	sta	(inbuff),y
	jmp	vect1		; go print rest
	endproc


