$title(MAC65/XL Cartridge  (c) 1988 ICD Inc)
$subtitle(DDT debugging tool - for use with MAC/65)
$include "equate.asm"
$include "tokens.asm"


	seg	m_ddt
;==================================
;	Flash & mac ddt entry
;	--------------------
nkybd	proc
	sta	bank3		; insurance...
	jmp	_nkybd		; go to it
	endproc


;	call (jsr) entry point
;	----------------------
ddt:	proc				; save some mac system
	ldy	#$80-(runstk-xcii)	; this # should be +
..zsav0	lda	xcii-($80-(runstk-xcii)),y
	sta	(lomem),y
	 iny	
	 bpl	..zsav0
				;  save upper half of page 0
..zsav1	lda	0,y
	sta	(lomem),y
	iny	
	bne	..zsav1
	sty	zpsflg		; set ddt mode

	tya			; a=0
	ldx	#14
..cbp2	sta	brkp0,x
	dex	
	bpl	..cbp2

ddtwrm:	SEI			; set up keyboard vector
	sta	bank3		; ^^^^^^^^^ bank 3 ^^^^^^^^^
	jsr	sddtx		; set brk vector

	ldx	#1
..rvec1	lda	vkeybd,x
	sta	vkeysv,x
	lda	keyld,x
	sta	vkeybd,x
	 dex	
	 bpl	..rvec1

	CLI	
	jsr	save
	pla	
	pla	

	lda	#low quitddt
	sta	pcsav
	lda	#high quitddt
	jmp	ddtx1
	endproc



;	quit
;	----
quitddt	proc
	lda	#4		; clear all bkps
..qclr	pha	
	jsr	clbrk
	pla	
	sec	
	sbc	#1
	bpl	..qclr

	jsr	usersc
	SEI	
	lda	vkeysv
	sta	vkeybd
	lda	vkeysv+1
	sta	vkeybd+1
	CLI	

	ldy	#$80-(runstk-xcii)	; this # should be +
..zlod0	lda	(lomem),y
	sta	xcii-($80-(runstk-xcii)),y
	 iny	
	 bpl	..zlod0

;	ldy #$80
..zload	lda	(lomem),y
	sta	0,y
	 iny	
	 bne	..zload

	jsr	cartrtn		; some init
	jmp	warm		; go to mac warm
	endproc



;	subroutine  ddt  (brk entry)
;	----------------------------
ddtx	proc
	sta	bank3		; ^^^^^^^^^ bank 3 ^^^^^^^^^
	pla			;restore acc
	plp			;and p reg
	jsr	save
	pla	
	sbc	#2		;correct for brk quirk
ddtx1a	sta	pcsav
	pla	
	sbc	#0
ddtx1	sta	pcsav+1
	tsx	
	stx	spsav
	CLI			;clear interrupt disable

	lda	#0
	sta	dscnfl		;set flag to dbug screen off
	sta	windf
	sta	ssflg		;clear ss auto flag
	jsr	clbrk		;clear breakpoint 0
	jsr	pcsexa		;set up window index
	jsr	sctog		;turn on dbug screen
	sta	bank3		; ^^^^^^^^^ bank 3 ^^^^^^^^^^^
	jmp	dbnd5
	endproc


mnctab	db	"BRADEAINAPHXPHY"
	db	"PLXPLYSTZSTZTRB"
	db	"TSBADCANDBITCMP"
	db	"EORJMPLDAORASBC"
	db	"STA"


gmnetab proc
	lda	vcount		; so display doesn't jump
..ggm	cmp	vcount		; tight timing!!!
	beq	..ggm		; not yet ready
			;   need 21 machine cycles
	pha	
	pla	
	pha	
	pla	
	pha	
	pla	
..gmn	sta	bank1		; get chars quickly ^^^^^^^^^ bank 1 ^^^^^^^
	lda	mnetab+2,x
	pha	
	lda	mnetab+1,x
	pha	
	lda	mnetab,x
	sta	bank3		; ^^^^^^^^^^^ bank 3 ^^^^^^^^^^
	jsr	shlet		; show 1st
	pla	
	jsr	shlet		; show 2nd
	pla	
	and	#$7f
			;  fall thru & return

;	show letter
;	-----------
; puts letter, in reverse video if overlayed by brk

shlet	jsr	intrep		; get screen code
	ora	brkor
	sta	(dindir),y
	iny	
	rts	
	endproc


$eject
	seg	e_ddt
;============================================
;	Must align on an even boundary
;	------------------------------
	db	$ff	; this insures that high (symbol-1) on same page!
			;  INDX assumed to be first - because of $if directive

;	Addressing mode processors
;	--------------------------
indx	proc
	jsr	lpar
	jsr	nxby
	jsr	comx
	jmp	rpar
	endproc

indy	proc
	jsr	lpar
	jsr	nxby
	jsr	rpar
	jmp	comy
	endproc

imm	proc
	lda	#3		; #
	sta	(dindir),y
	iny	
	iny	
	jsr	dollar
	lda	stemp
	jmp	shhex
	endproc

zx	proc
	lda	itemp
	cmp	#$96		;ck if exception
	beq	zy
	cmp	#$b6
	beq	zy
	jsr	nxby
	jmp	comx
	endproc

zy	proc
	jsr	nxby
	jmp	comy
	endproc

ind	proc
	jsr	lpar
	jsr	nxad
	jmp	rpar
	endproc

absx	proc
	lda	itemp
	cmp	#$be
	beq	absy
	jsr	nxad
	jmp	comx
	endproc

absy	proc
	jsr	nxad
	jmp	comy
	endproc

rel	proc
	lda	stemp		;now offset
	pha	
	and	#$80
	bmi	..relbk

	lda	#93		; forward branch
	sta	(dindir),y
	ldy	#0
..rel0	pla	
	clc	
	adc	dndr2
	tax	
	tya	
	adc	dndr2+1
	tay	
	txa	
	clc	
	adc	#2
	sta	stemp
	tya	
	adc	#0
	ldy	#15
	jsr	shhex
	lda	stemp
	jmp	shhex

..relbk	lda	#92		; backward branch
	sta	(dindir),y
	ldy	#$ff
	bne	..rel0
	endproc

acc	proc
	lda	#'A'-$20	; A
	bne	setch

izpg	jsr	lpar
	jsr	nxby
	jmp	rpar

absix	jsr	lpar
	jsr	nxad
	jsr	comx
	jmp	rpar

z
nxby	jsr	dollar
	bne	nxby1

imp	rts	

abs
nxad	jsr	dollar
	lda	stemp+1
	jsr	shhex
nxby1	lda	stemp
	jmp	shhex

	$if (nxad-indx) > 254
	 $error "DDT addressing modes too long!"
	$endif


;	Output special chars
;	--------------------
lpar	proc
	lda	#'('-$20
	bne	setch
dollar	lda	#'$'-$20
	bne	setch
rpar	lda	#')'-$20
	bne	setch
com	lda	#','-$20
	bne	setch

comx	jsr	com
	lda	#'X'-$20
	bne	setch

comy	jsr	com
	lda	#'Y'-$20
setch	sta	(dindir),y
	iny	
	rts	
	endproc


$eject
	seg	c_ddt
;===============================================
;	Main (banked) portion of DDT code
;	---------------------------------

;	this is the main active ddt loop
;	--------------------------------
dbnd5	proc
	jsr	setpu		;clear the command buffer

	ldy	#14		;num. of spaces to clear
	lda	#0
clrc1	sta	(dindir),y
	dey	
	bpl	clrc1
	iny	
	lda	#$80
	sta	(dindir),y
	sty	chcol

dbnd5a	lda	ssflg		;ck if in auto mode
	beq	dbn56
	lda	brkkey		;ck if break has been hit
	bne	dbn55
	inc	brkkey		;turn off break indicator
dbn60	lda	#0
	sta	ssflg		;ok, so turn off ss auto flag
	lda	crstat
	sta	crsinh		;also restore cursor state
	lda	poksav
	ora	$7f
	and	pokmsk
	sta	pokmsk
	sta	irqen
	lda	dscnfl		;set screen todbug
	bne	dbn56
	jsr	pcsexa
	jsr	sctog
	bne	dbn56
dbn55	jsr	gtnxin		;ck next inst
	beq	dbn60
	jmp	sstep1		;so, go do next instr.
dbn56	lda	#1		;ck if start pressed
	bit	consol
	bne	dcon2
	jsr	deboun
	jmp	dcont


dcon2	lda	consol		;ck if select
	and	#2
	bne	dcon1
	jsr	sctog		;toggle screen
	jsr	deboun
	beq	dbnd5

dcon1	lda	#4
	bit	consol		;ck if option
	bne	dcmdi
	jsr	deboun
	jmp	sstep

dcmdi	jsr	ckgetc		;ck keypress
	bcs	dbnd5a
	ldx	#13		;num of values to try
onli1	cmp	keytb,x		;ck value
	beq	onli2
	dex			;if not it, get ready for next
	bpl	onli1
	jmp	dbnd5a

onli2	txa	
	asl	a
	tay	
	lda	keyru+1,y
	pha	
	lda	keyru,y
	pha	
	lda	cmdcd,x		;get the internal rep.
	jsr	click		;click
	jmp	putch		;put char & call key routine
	endproc


dcont	proc
	jsr	usersc
	lda	#$c0
	sta	nmien		;restore nmi s
	ldx	spsav		;restore stack pointer
	txs	
	lda	pcsav+1		;now restore state
	pha	
	lda	pcsav
	pha	
	lda	psav
	pha	
	ldx	xsav
	ldy	ysav
	lda	#83
	sta	ddtact		;enable flash entry
	lda	asav
	rti	
	endproc


keytb	db 42,61,21,40,58,15,13
	db 46,14,62,7,35,$2f
	db $25

cmdcd	db 37,39,34,50,36,93,41
	db 55,92,51,10,46,49
	db $2d


keyru	dw exam-1,go-1,stbrk-1,regis-1,depos-1
	dw pullwi-1,interp-1,chwin-1
	dw pushw-1,serch-1,pcset-1,next-1,quitddt-1
	dw move-1


;	flash (keyboard) entry
;	----------------------
_nkybd	proc
	lda	kbcode		;get keyboard character
	cmp	#dbchr
	bne	nkyb3		;if not dbug entry char. continue
	lda	#$ff
	sta	chr
	lda	ddtact		;ck if ddt already active
	cmp	#69		;already there
	bne	nkyb4
	lda	#dbchr
	bne	nkyb3
nkyb4	pla	
	plp	
	jsr	save
	pla	
	jmp	ddtx1a

nkyb3	jmp	(vkeysv)

keyld	dw nkybd
	endproc



;	save caller's status
;	(except stack register)
;	-----------------------
save	proc
	sta	asav		;a
	php	
	lda	#69
	sta	ddtact		;disable flash entry
	pla	
	sta	psav		;p
	stx	xsav		;x
	sty	ysav		;y
	cld			;no decimal mode
	sec			;for pc manipulation
	rts			;return
	endproc


savad	db	low vvblki, low vvbkih, low vvblkd
	db	low vvbkdh, low sdmctl, low sdlstl, low sdlsth
	db	low gprior, low color1, low color2, low color4
	db	low chact,  low chbas


;	set display list
;	----------------
setdl	proc
	ldx	windf
	lda	dlsttb,x
	sta	sdlstl
	 lda	#high ddtlst
	 sta	sdlstl+1
	rts	
	endproc


dif	equ	dscd3-dscd2

septb	db 4,9,14,19,28
	db dif+4, dif+7, dif+10
	db dif+13, dif+16


;	set breakpoint
;	--------------
; in:
;	acc	= breakpoint #
;	btemp	= breakpoint loc.

setbp	proc
	jsr	times3
	lda	brkp0,x		;ck if set
	ora	brkp0+1,x
	beq	..setb2
	lda	btemp
	pha			;save temp
	lda	btemp+1
	pha	
	lda	brkp0,x		;if not, first restore
	sta	btemp
	lda	brkp0+1,x
	sta	btemp+1
	txa	
	pha	
	jsr	restor
	pla	
	tax	
	pla			;now restore btemp
	sta	btemp+1
	pla	
	sta	btemp

..setb2	ldy	#0		;set=0 for dindir
	lda	btemp+1
	sta	dindir+1
	sta	brkp0+1,x	;set up pointer to breakpoint
	lda	btemp
	sta	dindir
	sta	brkp0,x
	lda	(dindir),y	;get current value
	sta	brkp0+2,x	;and save
	lda	#0
	sta	(dindir),y	;set breakpoint

sddtx	lda	#low ddtx
	sta	vbreak
	 lda	#high ddtx
	 sta	vbreak+1
rste	rts	
	endproc


;	clear breakpoint
;	----------------
; in:
;	acc	= brkpt to clear

clbrk	proc
	jsr	times3
	lda	brkp0,x
	sta	btemp
	lda	brkp0+1,x
	sta	btemp+1

			;  restore breakpoint
restor	lda	btemp
	sta	dindir
	lda	btemp+1
	sta	dindir+1
	jsr	stbpp		;set pointer
	bcs	rste		;if not found, exit

rest6	lda	brkp0+2,x	;get proper instruction
	ldy	#0		;set up y for dindirect
	sta	(dindir),y	;restore
	tya			;move 0 to acc
	sta	brkp0,x
	sta	brkp0+1,x	;clear out breakpoint
	sta	brkp0+2,x
	rts	
	endproc


;	set breakpoint pointer
;	----------------------
stbpp	proc
	ldx	#0		;get ready to restore instruction
..r0	lda	btemp		;load a with low byte of brkp loc
	cmp	brkp0,x		;this should equal one of the brkps
	beq	..r1		;is this it?
..r3	inx			; no. increment x and try again
	inx	
	inx	
	cpx	#15		;ck if at end of table
	bne	..r0
	sec			;set not found flag
	rts	

			;  first byte was equal
..r1	lda	btemp+1		;get high byte of pc
	cmp	brkp0+1,x	;is this it?
	bne	..r3		;no, try again

	clc		;  second byte equal
	rts	
	endproc



;	multiply by 3 (put in X)
;	------------------------
times3	proc
	sta	itbyte		;save value temporarily
	asl	a		;multiply *2
	adc	itbyte
	tax	
	rts	
	endproc


;	move pcsav to examwi
;	--------------------
pcsexa	proc
	lda	pcsav
	sta	examwi
	 lda	pcsav+1
	 sta	examwi+1
user1	rts	
	endproc


;	set user screen
;	---------------
usersc	proc
	lda	dscnfl		;ck state of display
	beq	user1		;toggle screen if necessary

			; toggles between ddt screen &
			;  the normal one
sctog	ldx	#0
	stx	nmien		; zap all interrupts
	lda	dscnfl
	beq	dbsc1		;ck what state the screen is in
	 stx	dscnfl

	ldx	#12		; restore graphics
..rsgr	ldy	savad,x
	lda	grsav,x
	sta	$0200,y
	dex	
	bpl	..rsgr

	$if 0			; not needed???
	 lda	sdlstl
	 sta	dlistl
	  lda	sdlstl+1
	  sta	dlistl+1
	$endif

	lda	sdmctl
;	sta	dmactl		; not needed???
	and	#$0c
	lsr	a
	lsr	a
	sta	gractl
	lda	#$c0
	sta	nmien		;allow dma
	rts	

dbsc1	inc	dscnfl
	ldx	#13		; save graphics
..svgp	ldy	savad-1,x
	lda	$0200,y
	sta	grsav-1,x
	dex	
	bne	..svgp
				;  x=0
	stx	gprior		;set priority

			; clear and set up the screen
	txa			; set a=0
..cdsc	sta	dscd1,x
	sta	dscd1+(284-256),x
	 dex	
	 bne	..cdsc

			; now draw separator lines
	ldx	#10
	$if text=10
	 stx	color1
	$endif

	lda	#124
..dli3	ldy	septb-1,x
	sta	dscd2,y
	dex	
	bne	..dli3		; x=0

			; and set up dbug color regs
	$if bordr<>4
	 lda	#bordr
	 sta	color4
	$endif

	$if text<>10
	 lda	#text
	 sta	color1
	$endif

	$if bkgnd<>0
	 lda	#bkgnd
	 sta	color2
	$endif

	lda	#low kchact
	sta	chact
	 lda	#high kchact
	 sta	chact+1
	jsr	setdl
	ldx	#4
	lda	#0

	$if bordr=4
	 stx	color4
	$endif

	$if bkgnd=0
	 sta	color2
	$endif

	sta	gractl
..tog1	sta	grafp0,x
	dex	
	bpl	..tog1

	lda	#$21		; narrow screen
	sta	sdmctl
;	sta	dmactl		; not needed???

	lda	#low kvvbki
	sta	vvblki
	 ldx	#high kvvbki
	 stx	vvblki+1
	lda	#low kvvbkd
	sta	vvblkd

	$if high kvvbkd <> high kvvbki
	 ldx	#high kvvbkd
	$endif

	stx	vvblkd+1
	lda	#$40
	sta	nmien
			;    and update dynamic parts
			;    show screen
sscrn	lda	#low dscd2
	sta	dindir		;pt to screen brk area
	 lda	#high dscd2
	 sta	dindir+1

	ldx	#3
	lda	#0
	ldy	#29
shbk0	sta	(dindir),y
	iny	
	dex	
	bne	shbk0
	tay	
shbk1	lda	brkp0+4,x	;get first byte of address
	jsr	shhex
	lda	brkp0+3,x
	jsr	shhex
	inx	
	inx	
	inx	
	iny	
	cpy	#20
	bne	shbk1
	jsr	shstat		;and register state

			;  and fall into dwind

;	display window
;	--------------
dwind	lda	examwi
;	sec
;	sbc	#2
	sta	dndr2		;back window up 2
	 lda	examwi+1
;	 sbc	#0
	 sta	dndr2+1

	lda	#low (dscd1+6)
	sta	dindir		;pt to 1st data area
	 lda	#high (dscd1+6)
	 sta	dindir+1
	lda	#$1e
	sta	dscd1+4
	lda	windf		;ck which filter is in
	beq	dwin1
	 jmp	dhexw

dwin1	lda	#10
	sta	tbyte		;bytes to show
dis1	lda	#0
	sta	mprot		;bytes to protect initially
dis11	jsr	clin		;clear line
	lda	dndr2+1		;high byte of address loc
	jsr	shhex
	lda	dndr2
	jsr	shhex
	ldy	#2
	lda	(dndr2),y	;now get 3 values
	sta	stemp+1
	dey	
	lda	(dndr2),y
	sta	stemp
	dey	
	lda	(dndr2),y
	sta	itemp
	ldy	#6
	jsr	shhex

			; now do the disassembly
	lda	mprot		;check if byte is protected
	bne	nxins
	sta	undff		;clear undefined flag
	sta	brkor		;and brk display flag
	lda	itemp
	bne	dis2		;make sure it's not a brk
	jsr	brins
	sta	itemp
	lda	#$80
	sta	brkor
	lda	itemp

dis2	jsr	detlen		;get length of ins.
	sta	mprot
	ldy	#$09
	bcs	undef
	ldx	#$9e		;try to find opcode pattern
patl1	lda	itemp		;get opcode
	and	pattab,x	;mask off don't cares
	cmp	pattab+1,x	;see if it matches
	beq	patfd
	dex	
	dex	
	jmp	patl1

patfd	txa			;yep, this is it
	lsr	a		;divide by 2
	cmp	#56
	bcs	pat65c
	jsr	times3
	jsr	gmnetab		; get table bank
patjn	jsr	shwad		;and the address mode
nxins	jsr	nxline
	inc	dndr2		;and memory address
	bne	nxi2
	inc	dndr2+1
nxi2	dec	mprot
	dec	tbyte
	beq	sscr9
	jmp	dis11
sscr9	rts	

undef	lda	#1
	sta	mprot
	ldx	#3
undf1	lda	#'?'
	jsr	shlet
	dex	
	bne	undf1
	beq	nxins

pat65c	sbc	#56
	jsr	times3
	lda	mnctab,x	;show mnem.
	jsr	shlet
	lda	mnctab+1,x
	jsr	shlet
	lda	mnctab+2,x
;	and	#$7f		;strip off steve's bit 7
	jsr	shlet
	jmp	patjn

dhexw	lda	dndr2
	and	#3
	eor	#$ff
	clc	
	adc	#5
	jsr	dhlin		;show current line
	beq	dhxw0
	 rts	

dhxw0	lda	#9
	sta	stemp
dhxw1	jsr	nxline
	lda	#4		;show 4 bytes from here on
	jsr	dhlin
	dec	stemp
	bne	dhxw1
	rts	
	endproc


dhlin	proc
	sta	tbyte		;byte to show
	sta	mprot
	jsr	clin
	lda	dndr2+1
	pha	
	jsr	shhex
	lda	dndr2
	pha	
	jsr	shhex
	ldy	#6
	ldx	#0
dhln1	lda	(dndr2,x)	;this gets next value to show
	jsr	shhex
	iny	
	inc	dndr2
	bne	dhln15
	 inc	dndr2+1

dhln15	dec	tbyte
	bne	dhln1		;if any more show
	lda	mprot
	sta	tbyte
	ldy	#18		;now do atascii decoding
	pla	
	sta	dndr2
	pla	
	sta	dndr2+1
dhln2	lda	(dndr2,x)
	jsr	intrep
	sta	(dindir),y
	iny	
	inc	dndr2
	bne	dhln25
	 inc	dndr2+1

dhln25	dec	tbyte
	bne	dhln2
	rts	
	endproc



;	next line
;	---------
nxline	proc
	clc	
	lda	dindir
	adc	#28
	sta	dindir
	bcc	nxl1
	 inc	dindir+1
nxl1	rts	
	endproc




;	clear display window line
;	-------------------------
clin	proc
	lda	#0
	tay	
..clin1	sta	(dindir),y
	iny	
	cpy	#26
	bne	..clin1
	tay	
	rts	
	endproc


;	debounces the console
;	---------------------
deboun	proc
	lda	rtclok
	clc	
	adc	#$20
	sta	itbyte
..debos	lda	#8
	sta	consol
	lda	consol
	cmp	#7
	beq	..deb
	 lda	rtclok
	 cmp	itbyte
	 bne	..debos
	rts	

..deb	lda	rtclok
	clc	
	adc	#3
..db2	cmp	rtclok
	bne	..db2
	lda	consol
	cmp	#7
	bne	deboun
	rts	
	endproc


;	this routine retrieves the proper breakpoint instruction
;	--------------------------------------------------------
brins	proc
	jsr	dndbte
	jsr	stbpp
	bcc	bri2
	 lda	#0
	 rts	
bri2	lda	brkp0+2,x
	rts	
	endproc



;	determine length
;	----------------
; this routine determines the length of the opcode passed in the acc

detlen	proc
	pha	
	lsr	a		; this computes proper table byte
	lsr	a
	tax	
	pla	
	and	#3		; mask off doublet counter
	tay	
	lda	lim,x		;get proper byte from table
	cpy	#0		;check if 0 doublet selected
	beq	detl2
detl1	lsr	a
	lsr	a		;shift doublet to 0'th position
	dey			;decrement doublet ctr
	bne	detl1		;loop if necessary
detl2	clc	
	and	#3		;mask off the 0'th doublet
	bne	detl3
	lda	#1
	sec	
detl3	tay			;needed for sstep
	rts	
	endproc


lim	db $09,$2a,$19,$3f
	db $2a,$2a,$1d,$3f
	db $0b,$2a,$19,$3f
	db $2a,$2a,$1d,$3f
	db $09,$28,$19,$3f
	db $2a,$28,$1d,$3c
	db $09,$2a,$19,$3f
	db $2a,$2a,$1d,$3f
	db $0a,$2a,$11,$3f
	db $2a,$2a,$1d,$3f
	db $2a,$2a,$19,$3f
	db $2a,$2a,$1d,$3f
	db $0a,$2a,$19,$3f
	db $2a,$28,$1d,$3c
	db $0a,$2a,$19,$3f
	db $2a,$28,$1d,$3c


;	move dndr2 to btemp
;	-------------------
dndbte	proc
	lda	dndr2
	sta	btemp
	 lda	dndr2+1
	 sta	btemp+1
	rts	
	endproc


;	vsync
;	-----
vsync	proc
	lda	#$7b
..vsyn1	cmp	vcount
	bne	..vsyn1
	rts	
	endproc



;	internal representation
;	-----------------------
intrep	proc
	pha	
	and	#$80
	sta	itbyte
	pla	
	and	#$7f
	cmp	#32
	bmi	..intr1
	cmp	#96
	bpl	inram
	sec	
	sbc	#32
	bpl	inram
..intr1	ora	#64
inram	ora	itbyte
	rts	
	endproc



;	show state
;	----------
; this routine is used to
; show the values of the
; register states

shstat	proc
	lda	#low dscd3
	sta	dindir		;ptr to dbug screen
	 lda	#high dscd3
	 sta	dindir+1
	ldy	#0
	lda	pcsav+1		;now show values
	jsr	shhex
	lda	pcsav
	jsr	shhex
	iny	
	ldx	#0
..shst	lda	asav,x
	jsr	shhex
	iny	
	inx	
	cpx	#4
	bne	..shst

	lda	#low (dscd2+20)
	sta	dindir
	 lda	#high (dscd2+20)
	 sta	dindir+1

	ldy	#0
	lda	psav
	ldx	#8		;set up counter for digits
..shb	asl	a		;shift left to get bit in carry
	pha			;save temp
	lda	#16		;load value for 0
	adc	#0		;value is 17 for 1
	sta	(dindir),y
	iny	
	pla	
	dex	
	bne	..shb
	rts	
	endproc



;	show hex
;	--------
; this routine is used to
;   show a value in the acc
;   in hex notation
; the routine assumes dindir
;   & y are set to point to
;   location for show

shhex	proc
	pha			;save temp
	lsr	a
	lsr	a
	lsr	a		;get left nibble to right
	lsr	a
	jsr	hxdig
	pla	
	and	#$0f		;now mask off right nibble

			;   and fall thru into hxdig
hxdig	clc	
	adc	#16		;add offset for numbers
	cmp	#26		;ck if > 10
	bcc	..hx0
	 clc	
	 adc	#7		;add hex offset
..hx0	sta	(dindir),y
	iny	
	rts	
	endproc




;	show address mode
;	-----------------
shwad	proc
	lda	undff		;check if instruction undefined
	beq	..shad1
	 rts	

..shad1	ldx	#0
..shad2	lda	itemp		;get op  code
	and	adpat,x		;mask off dont cares
	inx	
	cmp	adpat,x		;does it match the mandatory part?
	beq	..adfnd		;yes
	inx	
	inx	
	bne	..shad2		;no, try next

..adfnd	inx	
	lda	adpat,x		;get address mode
	tax	
	lda	#high indx
	pha	
	lda	adrou,x		;get low byte
	pha	
	iny	
	rts			;go to mode routine
	endproc



pattab	db $ff,$20,$df,$4c,$e7,$c6,$e7,$e6,$e3,$a2
	db $e3,$a0,$e7,$86,$e7,$84,$f3,$e0,$f3,$c0
	db $f7,$24,$ff,$00,$ff,$18,$ff,$d8,$ff,$58
	db $ff,$b8,$ff,$ca,$ff,$88,$ff,$e8,$ff,$c8
	db $ff,$ea,$ff,$48,$ff,$08,$ff,$68,$ff,$28
	db $ff,$40,$ff,$60,$ff,$38,$ff,$f8,$ff,$78
	db $ff,$aa,$ff,$a8,$ff,$ba,$ff,$8a,$ff,$9a
	db $ff,$98,$ff,$90,$ff,$b0,$ff,$f0,$ff,$30
	db $ff,$d0,$ff,$10,$ff,$50,$ff,$70,$e3,$01
	db $e3,$21,$e3,$41,$e3,$61,$e3,$81,$e3,$a1
	db $e3,$c1,$e3,$e1,$e3,$02,$e3,$22,$e3,$42
	db $e3,$62

; ** start of 6502c patterns  **
	db $ff,$80,$ff,$3a,$ff,$1a,$ff,$da,$ff,$5a
	db $ff,$fa,$ff,$7a,$fd,$9c,$ef,$64,$f7,$14,$f7,$04

; and the funny address modes
	db $ff,$72,$ff,$32,$f7,$34,$ff,$d2,$ff,$52,$ff,$7c
	db $ff,$b2,$ff,$12,$ff,$f2,$ff,$92


;	Addressing mode handlers
;	------------------------
adrou	db	low indx-1, low indy-1, low imm-1, low zx-1
	db	low zy-1,   low ind-1,  low acc-1, low rel-1
	db	low absx-1, low absy-1, low abs-1, low z-1
	db	low imp-1,  low izpg-1, low absix-1

adpat	db $1f,$01,$00, $1f,$11,$01
	db $1f,$09,$02, $ff,$a2,$02
	db $bf,$a0,$02, $ff,$c0,$02
	db $1f,$15,$03, $df,$94,$03
	db $1f,$16,$03, $df,$96,$04
	db $ff,$6c,$05, $9f,$0a,$06
	db $1f,$10,$07, $1f,$1d,$08
	db $1f,$1e,$08, $ff,$bc,$08
	db $1f,$19,$09, $ff,$be,$09
	db $1f,$0d,$0a, $1f,$0e,$0a
	db $1f,$0c,$0a, $ff,$20,$0a
	db $1f,$05,$0b, $1f,$06,$0b
	db $7f,$24,$0b, $bf,$84,$0b
	db $ff,$e4,$0b, $bf,$00,$0c
	db $ff,$60,$0c, $0f,$08,$0c
	db $8f,$8a,$0c

;  ** start of 6502c patterns  **
	db $ff,$80,$07,$ff,$3a,$06
	db $ff,$1a,$06,$ff,$da,$0c
	db $ff,$5a,$0c,$ff,$fa,$0c
	db $ff,$7a,$0c,$ff,$9c,$0a
	db $ff,$9e,$08,$ff,$64,$0b
	db $ff,$74,$03,$ff,$1c,$0a
	db $ff,$14,$0b,$ff,$0c,$0a
	db $ff,$04,$0b,$1f,$12,$0d
	db $ff,$7c,$0e,$ff,$3c,$08
	db $ff,$34,$03


;	get next instruction
;	--------------------
gtnxin	proc
	lda	pcsav
	sta	dndr2
	 lda	pcsav+1
	 sta	dndr2+1
	ldy	#0
	lda	(dndr2),y	;get instruction
	rts	
	endproc


;	single step
;	-----------
sstep	proc
	jsr	gtnxin
	bne	sstep1		;make sure it's not a brk
	jsr	brins		;otherwise, get it
	bne	sstep1
	jmp	ssrt2
sstep1	sta	itemp
	ldx	#14
	lda	itemp
tfor2	cmp	forb,x
	bne	nfnd		;ck if op code in on forbidden list
	cpx	#9
	bcc	ssbc		;simulate conditional branch
	lda	ssrouh-9,x	;get address of routine
	pha	
	lda	ssroul-9,x
	pha	
	rts			;goto routine
	endproc

ssroul	db	low (ssjmp-1), low (ssjmi-1)
	db	low (ssjsr-1), low (ssrti-1), low (ssrts-1)
	db	low (ssjii-1)

ssrouh	db	high (ssjmp-1), high (ssjmi-1)
	db	high (ssjsr-1),	high (ssrti-1), high (ssrts-1)
	db	high (ssjii-1)

ssbc	proc
	lda	pcsav
	adc	#2
	sta	pcsav
	bcc	..ssbc
	 inc	pcsav+1

..ssbc	jsr	ptbed
	lda	itemp
	sta	tbed		;put in test bed
	 lda	#4		;offset to 2nd jmp ins.
	 sta	tbed+1
	bne	sst2		;unconditional
	endproc


forb	db	$90,$b0,$f0,$d0,$30,$10,$50,$70,$80
	db	$4c,$6c,$20,$40,$60,$7c

nfnd	proc
	dex	
	bpl	tfor2
	jsr	ptbed		; prepare test bed
	lda	itemp
	jsr	detlen		;get length
	bcc	sst01
	inc	pcsav
	bne	ssrt2
	 inc	pcsav+1
	bne	ssrt2		;unconditional

sst01	tya	
	tax	
	dex	
	dey	
	clc	
	adc	pcsav		;set pc after instr.
	sta	pcsav
	bcc	..sst1
	 inc	pcsav+1

..sst1	lda	(dndr2),y	;move instr. to test bed
	sta	tbed,x
	 dex	
	 dey	
	 bpl	..sst1
	lda	itemp		;just in case it was a brk
	sta	tbed

sst2	ldx	spsav
	txs	
	ldx	xsav		;restore register state
	ldy	ysav
	lda	psav
	pha	
	lda	asav
	plp	
	jmp	tbed		;execute instruction
	endproc

ssret	proc
	sta	asav		;save register state again
	stx	xsav
	sty	ysav
	php	
	pla	
	sta	psav
	cld			;force binary mode
	cli	
ssrt1	tsx	
	stx	spsav
ssrt2	lda	dscnfl		;ck if we need to update
	beq	ssrt3
	jsr	vsync
	jsr	shstat		;update register state
	jsr	pcsexa		;set memory window index
	lda	#0
	sta	windf
	jsr	vsync
	jsr	sscrn
ssrt3	jmp	dbnd5a		;go back and check console
	endproc


;	Prepare test bed
;	----------------
ptbed	proc
	ldx	#8
..ptb1	lda	tbedx,x
	sta	tbed,x
	dex	
	bpl	..ptb1
	rts	
	endproc


ssjmp	proc
	jsr	pcad		;set pc to next add
	jmp	ssrt2
	endproc

ssjmi	proc
	jsr	sssind
ssjm2	lda	(dindir),y
	sta	pcsav+1
	dey	
	lda	(dindir),y
	sta	pcsav
	jmp	ssrt2
	endproc

ssjii	proc
	jsr	sssind
	lda	dindir
	clc	
	adc	xsav
	sta	dindir
	bcc	ssjm2
	 inc	dindir+1
	bcs	ssjm2		; always
	endproc


pcad	proc
	ldy	#1
	lda	(dndr2),y
	sta	pcsav
	 iny	
	 lda	(dndr2),y
	 sta	pcsav+1
	rts	
	endproc

ssrts	proc
	pla			;note: carry is set...
	adc	#0		;correct for jsr weirdness
	sta	pcsav
	pla	
	adc	#0
	sta	pcsav+1
	jmp	ssrt1
	endproc


ssjsr	proc
	jsr	pcad
	clc	
	lda	dndr2
	adc	#2
	tay	
	 lda	dndr2+1
	 adc	#0
	 pha	
	tya	
	pha	
	jmp	ssrt1
	endproc


ssbc2	proc
	cld	
	cli	
	ldy	#1
	lda	(dndr2),y
	bpl	ssbc3		;this sets for for pos & neg offset
	 dey	
ssbc3	dey	
	clc	
	adc	pcsav
	sta	pcsav
	 tya	
	 adc	pcsav+1
	 sta	pcsav+1
	jmp	ssrt2
	endproc

ssrti	proc
	ldx	#-3
..ssrt	pla	
	sta	psav+3,x
	inx	
	bne	..ssrt
	jmp	ssrt1
	endproc


;	set single step indirect
;	------------------------
sssind	proc
	ldy	#2
	lda	(dndr2),y
	sta	dindir+1
	 dey	
	 lda	(dndr2),y	;set dindir to next ad
	 sta	dindir
	rts	
	endproc


getch	proc
	jsr	ckgetc
	bcs	getch
	ldx	#15
getc0	cmp	keycd,x		;ck if in key code table
	beq	getc2
	dex	
	bpl	getc0
	ldx	#4		;ck if in delimiter table
getc3	cmp	delcd,x
	beq	getc4
	dex	
	bpl	getc3
	cmp	#52		;ck if delete
	bne	getch
	lda	#0		;set delete indicator
	sec			;set  control flag
	bcs	getc7

getc2	txa	
	clc	
	adc	#16		;convert to hex
	cmp	#26
	bcc	getc7
	clc	
	adc	#7
	bne	getc7
getc4	sec			;set delimiter flag
getc7
			;  note fall through

;	click routine
;	-------------
click	php	
	ldx	#$7e
	pha	
..clik1	stx	consol
	lda	vcount
..clik2	cmp	vcount
	beq	..clik2
	dex	
	dex	
	bpl	..clik1
	pla	
	plp	
	rts	
	endproc


;	check and get character
;	-----------------------
ckgetc	proc
	lda	chr
	cmp	#$ff
	bne	ckgt1
	 rts	

ckgt1	ldx	#$ff
	stx	chr
	rts	
	endproc


;	constant tables
;	---------------
keycd	db 50,31,30,26,24,29,27,51,53,48
;	   0  1  2  3  4  5  6  7  8  9
	db 63,21,18,58,42,56
;	   a  b  c  d  e  f

delcd	db 33,32,12,55,7
;	   sp  , cr  >  *


;	putch
;	-----
putch	proc
	pha	
	jsr	setpu
	ldy	chcol
	pla	
	sta	(dindir),y
	iny	
	lda	#$80
	sta	(dindir),y
	sty	chcol
	rts	
	endproc


;	setpu
;	-----
setpu	proc
	lda	#low (dscd3+17)
	sta	dindir		;set ptr to buf
	 lda	#high (dscd3+17)
	 sta	dindir+1
	rts	
	endproc


;	pull memory window down
;	-----------------------
pullwi	proc
	lda	windf
	cmp	#1
	bne	..pull1
	inc	examwi
	bne	pull3
	 inc	examwi+1
	clc	
	bcc	pull3

..pull1	jsr	einsiz
	clc	
	adc	examwi
	sta	examwi
	bcc	pull3
	 inc	examwi+1

pull3	jsr	dwind
	jmp	dbnd5
	endproc



;	pushw
;	-----
; this routine pushes the window up 1 byte

pushw	proc
	lda	examwi
	bne	..push0
	 dec	examwi+1
..push0	dec	examwi
	jmp	pull3
	endproc


;	exam window instruction	size
;	----------------------------
einsiz	proc
	jsr	exadnd
	ldy	#0
	lda	(dndr2),y
	bne	..ein1
	 jsr	brins
..ein1	jmp	detlen
	endproc



;	move examwi to dndr2
;	--------------------
exadnd	proc
	lda	examwi
	sta	dndr2
	 lda	examwi+1
	 sta	dndr2+1
	rts	
	endproc



;	interp
;	------
; turn the interpretive flag on

interp	proc
	inc	ssflg
	lda	#0
	sta	windf
	lda	crsinh
	sta	crstat
	lda	pokmsk
	sta	poksav
	ora	#$80
	sta	pokmsk
	sta	irqen
	jmp	dbnd5
	endproc


;	next
;	----
next	proc
	jsr	einsiz		;get size of inst in examwi
	clc	
	adc	pcsav
	sta	btemp
	 lda	pcsav+1
	 adc	#0
	 sta	btemp+1
	lda	#0		;for internal bkp
	jsr	setbp
	jmp	dcont
	endproc



;	exam (examine)
;	--------------
exam	proc
	jsr	ogtadd		;space over 1 and get add
	bcs	..exam1		;ck if null address
	lda	hexval
	sta	examwi		;move address to exam window
	 lda	hexval+1
	 sta	examwi+1
	jsr	dwind		;show window
..exam1	jmp	dbnd5
	endproc


;	getval (get value)
;	------------------
getval	proc
	lda	#0
	sta	cc		;set char. counter to 0
..gtv1	jsr	getch		;get char.
	bcs	delim		;if delimiter
	ldx	cc
	cpx	fsize
	beq	..gtv1
	jsr	putch		;put char on screen
	inc	cc		;increment char. count
	bne	..gtv1

delim	cmp	#0
	beq	..deli2
	rts	

..deli2	ldx	cc
	bne	..deli3
	pla			;clear rts value
	pla	
	pla	
	pla	
	jmp	dbnd5

..deli3	dec	cc
	ldy	chcol
	sta	(dindir),y
	dey	
	lda	#$80
	sta	(dindir),y
	dec	chcol
	bne	..gtv1
	endproc


;	gtadd (get address)
;	-------------------
gtadd	proc
	jsr	putch
	lda	#4
	sta	fsize		;set field size
	jsr	getval		;get address value
	jsr	convrt
	bcc	gtadx
	cmp	#$37		;ck for >
	beq	gtaw		;yes, branch
	cmp	#$07		;ck for *
	bne	gtadx		;no, exit (carry set)
	lda	pcsav		;pc -> result
	sta	hexval
	lda	pcsav+1
	jmp	gtaw1

gtaw	lda	examwi		;window pos'n -> result
	sta	hexval
	lda	examwi+1
gtaw1	sta	hexval+1
	clc	
gtadx	rts	
	endproc


;	convert atascii to hex
;	----------------------
convrt	proc
	ldx	cc
	bne	..conv2
	 sec	
	 rts			;this flags null value
..conv2	lda	chcol
	sec	
	sbc	cc
	tay	
	jsr	setpu		;set pointer
	lda	#0
	sta	hexval
	sta	hexval+1
conv4	lda	(dindir),y	;get hex val
	cmp	#$20
	bcc	..gth1
	 clc	
	 adc	#9
..gth1	and	#$0f
	pha	
	iny			;set y to next character
	ldx	#4
..rotv1	asl	hexval
	rol	hexval+1
	dex	
	bne	..rotv1

	pla	
	ora	hexval
	sta	hexval
	dec	cc
	bne	conv4
	clc	
	rts	
	endproc



;	space over 1 and get add
;	------------------------
ogtadd	proc
	lda	#0		;space over 1 char.
	jmp	gtadd
	endproc


;	search routine
;	--------------
smtch	proc
	ldy	#0
..smt2	lda	sstr,y
	cmp	(dindir),y
	bne	..smno
	iny	
	cpy	sssiz
	bmi	..smt2
	sec	
	rts	

..smno	clc	
	rts	
	endproc



go	proc
	jsr	ogtadd		;get address value
	bcc	..gg
	 jmp	go1

..gg	lda	hexval
	sta	pcsav
	 lda	hexval+1
	 sta	pcsav+1
	jmp	dcont
	endproc


;	deposit
;	-------
depx.x	proc
	lda	#low sstr
	sta	dndr2
	 lda	#high sstr
	 sta	dndr2+1
	lda	#1
	bne	depxx

depos	jsr	exadnd		;set up indirect pointer
	lda	#0
depxx	sta	depsw
	lsr	a		; sets a=0
	jsr	putch		;get hex string
	lda	#12
	sta	fsize
	jsr	getval
	lda	chcol
	sec	
	sbc	cc
	sta	chcol
	lda	cc
	sta	tbyte
	lsr	a		;compute string size
	adc	#0
	sta	sssiz

depo0	lda	tbyte
	sec	
	sbc	#2
	bmi	depo2
	sta	tbyte
	lda	#2
	sta	cc
depo4	clc	
	adc	chcol
	sta	chcol
	jsr	convrt
	ldy	#0
	sta	(dndr2),y
	inc	dndr2
	bne	depo45
	 inc	dndr2+1
depo45	jmp	depo0

depo2	clc	
	adc	#1
	bmi	depo3
	sta	tbyte
	lda	#1
	sta	cc
	bne	depo4

depo3	lda	depsw
	beq	depo5
	rts	
	endproc



;	serch
;	-----
serch	proc
	lda	sssiz
	pha	
	jsr	depx.x
	lda	sssiz
	bne	..ser0
	pla			;get old val
	beq	go1
	sta	sssiz
	bne	..ser05
..ser0	 pla	

..ser05	lda	examwi
	clc	
	adc	#1
	sta	dindir
	 lda	examwi+1
	 adc	#0
	 sta	dindir+1
..ser1	jsr	smtch
	bcs	..sfnd
	inc	dindir
	bne	..ser1
	 inc	dindir+1
	 lda	dindir+1
	 cmp	#$d0
	 bne	..ser1
	beq	go1		; go dbnd5

..sfnd	lda	dindir
	ldx	dindir+1
	sta	examwi
	stx	examwi+1
depo5	jsr	sscrn
go1	jmp	dbnd5
	endproc


;	move (from addr, to addr, length)
;	---------------------------------
move	proc
	jsr	depx.x
	ldx	sssiz
	cpx	#6		; must be 3 words!
	bne	stbr6		; go "dbnd5"

	dex			; make low-high pairs
..lh	lda	sstr,x		; get low
	ldy	sstr-1,x	; get high
	sta	sstr-1,x	; store low
	sty	sstr,x		; store high
	dex			; point to next
	dex	
	bpl	..lh

$if 1
	ldx	sstr+5		; CART version
	bmi	stbr6
..top	ldy	#0
	txa
	bne	..dmv1
	 ldy	sstr+4
	 beq	depo5
..dmv1	sty	sstr+5
	jsr	aff0
	 inc	sstr+1
	 inc	sstr+3
	 dex	
	bpl	..top
	bmi	depo5
$else
	lda	sstr+4		; get length
	tay	
	ora	sstr+5
	beq	stbr6		; no zero lengths!
	ldx	sstr+5		; get high
	inx	
..dmv1	dey	
	lda	(sstr),y
	sta	(sstr+2),y
	tya	
	bne	..dmv1
	 inc	sstr+1
	 inc	sstr+3
	 dex	
	 bne	..dmv1
	beq	depo5		; all done
$endif
	endproc


;	stbrk (set breakpoint)
;	----------------------
stbrk	proc
	lda	#0
	jsr	gtbyt		;get value
	bcs	stbr6
	lda	hexval
	beq	stbr6
	cmp	#5
	bcs	stbr6
	pha			;save brkp #
	lda	#12		;for ,
	jsr	gtadd
	bcc	stbr4
	pla	
	jsr	clbrk		;clear brkpt
	jmp	stbr5

stbr4	lda	hexval
	sta	btemp
	 lda	hexval+1
	 sta	btemp+1
	pla			;get brkp # back
	jsr	setbp
stbr5	jsr	sscrn
stbr6	jmp	dbnd5
	endproc



;	regis (register change)
;	-----------------------
regis	proc
	lda	#0
	sta	cc
	jsr	putch		;space over
..reg1	jsr	ckgetc
	bcs	..reg1

	ldx	#2
..reg11	cmp	delcd,x
	beq	..reg5
	 dex	
	 bpl	..reg11

	cmp	#52		;?delete
	beq	..rdel
	tax	
	lda	cc
	bne	..reg1		;already typed one char.

	txa	
	ldx	#4
..reg2	cmp	regtb,x		;ck if chac. in table
	beq	..reg3
	dex	
	bpl	..reg2
	bmi	..reg1

..reg3	stx	itbyte
	lda	regcd,x
	jsr	click
	jsr	putch
	inc	cc
	bne	..reg1

..rdel	jsr	click
	lda	cc
	beq	stbr6
	dec	cc
	lda	#0
	ldy	chcol
	sta	(dindir),y
	 dey	
	 lda	#$80
	 sta	(dindir),y
	dec	chcol
	bne	..reg1

..reg5	lda	cc
	beq	stbr6
	jsr	click
	lda	#12		;load with value for ,
	jsr	gtbyt
	bcs	stbr6
	lda	hexval
	ldx	itbyte
	sta	asav,x
	jsr	shstat
	jmp	dbnd5
	endproc


;	set pc special for *
;	--------------------
pcset	proc
	jsr	ogtadd
	bcs	..reg9
	lda	hexval
	sta	pcsav
	 lda	hexval+1
	 sta	pcsav+1

..reg9	jsr	shstat
	ldx	pcsav+1
	lda	pcsav
	 sta	examwi
	 stx	examwi+1
	lda	#0
	beq	scpc		; change window!
	endproc


regtb	db 63,22,43,62,10
regcd	db 33,56,57,51,48


;	change window
;	-------------
chwin	proc
	lda	windf
	eor	#1
scpc	sta	windf
	jsr	setdl
	jmp	pull3		;jsr dwind ...jmp dbnd5
	endproc


;	get byte
;	--------
gtbyt	proc
	jsr	putch
	lda	#2
	sta	fsize
	jsr	getval
	jmp	convrt
	endproc


;	test bed
;	--------
tbedx	proc
	nop
	nop
	nop
	jmp	ssret		;back to ddt after execution
	jmp	ssbc2		;back after conditional branch
	endproc


;	display list
;	------------
dlsttb	db	low ddtlst, low ddtls1

ddtlst	proc
	db	$70,$70,$70
	db	66
	dw	tidis		;diss. title
	db	1		; this blanks 1 line
	dw	..ddtl2

ddtls1	db	$70,$70,$70
	db	66
	dw	tihex		;hex title
	db	0		; this blanks 1 line

..ddtl2	db	66
	dw	..ddtc
	db	66
	dw	dscd1		;display line 2
	db	66
	dw	dscd1+(1*28)
	db	66
	dw	dscd1+(2*28)
	db	66
	dw	dscd1+(3*28)
	db	66
	dw	dscd1+(4*28)
	db	66
	dw	dscd1+(5*28)
	db	66
	dw	dscd1+(6*28)
	db	66
	dw	dscd1+(7*28)
	db	66
	dw	dscd1+(8*28)
	db	66
	dw	dscd1+(9*28)
	db	$40,66
	dw	dscc2		;display line 17
	db	66
	dw	dscd2		;display line 19
	db	$40,66
	dw	dscc3		;display line 20
	db	66
	dw	dscd3		;display line 21
	db	65
	dw	ddtlst		;vertical retrace

;	DDT screen constant data
;	------------------------
dscc2	db	$A2, $AB, $B0, $91, $FC		; "BKP1|"
	db	$A2, $AB, $B0, $92, $FC		; "BKP2|"
	db	$A2, $AB, $B0, $93, $FC		; "BKP3|"
	db	$A2, $AB, $B0, $94, $FC		; "BKP4|"
	db	$AE, $B6, $80, $A2, $A4, $A9	; "NV BDI"
	db	$BA, $A3, $FC, $80, $80, $80	; "ZC|   "

tidis	equ	$-3
	db	$80, $80
	db	$80, $AC, $AF, $A3, $8E, $80	; " LOC. "
	db	$80, $B6, $A1, $AC, $80, $A9	; " VAL I"
	db	$AE, $B3, $B4, $B2, $B5, $A3	; "NSTRUC"
	db	$B4, $A9, $AF, $AE		; "TION"

tihex
	db	$80, $80, $80, $80
	db	$80, $80, $AC, $AF, $A3, $8E	; "  LOC."
	db	$80, $80, $80, $80, $80, $B6	; "     V"
	db	$A1, $AC, $B5, $A5, $B3, $80	; "ALUES "
	db	$80, $80, $A1, $B4, $A1, $8E	; "  ATA."
	db	$80, $80, $80			; "   "

	db	$80

;	Dunion's copyright
;	------------------
..ddtc	equ	$-2
	db	$A4, $A4, $B4, $80, $88, $A3	; "DDT (C"
	db	$89, $80, $91, $99, $98, $94	; ") 1984"
	db	$80, $AA, $A1, $AD, $A5, $B3	; " JAMES"
	db	$80, $AA, $8E, $80, $A4, $B5	; " J. DU"
	db	$AE, $A9, $AF, $AE, $80, $80	; "NION  "

;	display line 21
;	---------------
dscc3	equ	$-1

	db	$B0, $A3, $80, $FC, $A1, $80	; "PC |A "
	db	$FC, $B8, $80, $FC, $B9, $80	; "|X |Y "
	db	$FC, $B3, $80, $FC, $80, $A5	; "|S | E"
	db	$AE, $B4, $A5, $B2, $80, $A3	; "NTER C"
	db	$AF, $AD, $AD, $A1, $AE, $A4	; "OMMAND"
	db	$80				; " "


$if 1
	ds	$52
aff0	proc
	ldy	#0
..lp	lda	(sstr),y	; for CART version!!
	sta	(sstr+2),y
	iny
	cpy	sstr+5
	bne	..lp
	rts
	endproc
$endif
